<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:output method="text"/>

<xsl:param name="samplelength" select="72"/>

<xsl:template match="/">
  <xsl:apply-templates select="//verbatim | //sgml.block" mode="checkup"/>
</xsl:template>

<xsl:template match="verbatim | sgml.block"  mode="checkup" name="lengthcheck">
  <xsl:param name="string" select="string(.)"/>
  <xsl:variable name="thisline">
    <xsl:choose>
      <xsl:when test="contains($string,'&#xA;')">
        <xsl:value-of select="substring-before($string,'&#xA;')"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$string"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:variable>
  <xsl:if test="string-length($thisline) > $samplelength">
    <xsl:text>&#xA;&#xA;Line in code block longer than </xsl:text>
    <xsl:value-of select="$samplelength"/>
    <xsl:text> characters [</xsl:text>
    <xsl:value-of select="string-length($thisline)"/>
    <xsl:text>]:&#xA;  "</xsl:text>
    <xsl:value-of select="concat(substring($thisline,1,40),'...&quot;')"/>
    <xsl:text>&#xA;  in path </xsl:text>
    <xsl:apply-templates select="." mode="make-path"/>
    <xsl:text>&#xA;</xsl:text>
  </xsl:if>
  <xsl:if test="contains($string, '&#xA;')">
    <xsl:call-template name="lengthcheck">
      <xsl:with-param name="string" select="substring-after($string,'&#xA;')"/>
    </xsl:call-template>
  </xsl:if>
</xsl:template>

    
<xsl:include href="xpath-support.xsl"/>


</xsl:stylesheet>