<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0">
  
  <!-- runs on input that looks like this:
    
    <list>
<root>W:/Projects/Extreme2005/Proceedings/xml/</root>
<file>2001/Abe01/EML2001Abe01.xml</file>
<file>2001/Asperti01/EML2001Asperti01.xml</file>
<file>2001/Biezunski01/EML2001Biezunski01.xml</file>
...
    </list>

  -->

  <xsl:import href="extreme-char-warnings.xsl"/>
  
  <xsl:import href="extreme-uri-warnings.xsl"/>
  
  <xsl:import href="extreme-profile.xsl"/>

  <xsl:template match="/">
    <xsl:for-each select="//file">
      <xsl:variable name="file-path">
        <xsl:text>file:/</xsl:text>
        <xsl:value-of select="parent::list/root"/>
        <xsl:value-of select="."/>
      </xsl:variable>
      <xsl:for-each select="document($file-path)">
        <xsl:call-template name="extreme-tag-profile"/> 
        <!-- <xsl:call-template name="extreme-chars"/> -->
        <!--<xsl:call-template name="extreme-uri-warnings"/>-->
      </xsl:for-each>
    </xsl:for-each>
  </xsl:template>

</xsl:stylesheet>
