<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  version="1.0">
  
  <!-- generates XPaths for arbitrary nodes -->
  
  <xsl:template match="node()" mode="make-path">
    <xsl:apply-templates select="ancestor-or-self::node()" mode="make-step"/>
  </xsl:template>

  <xsl:template match="/" mode="make-step"/>
  <!-- we'll get an absolute path even without this step -->

  <xsl:template match="*" mode="make-step">
  <xsl:text>/</xsl:text>
  <xsl:value-of select="name()"/>
  <xsl:if test="(preceding-sibling::*|following-sibling::*)
                [name()=name(current())]">
    <xsl:text>[</xsl:text>
    <xsl:number/>
    <xsl:text>]</xsl:text>
  </xsl:if>
  </xsl:template>
  
  <xsl:template match="@*" mode="make-step">
  <xsl:text>/@</xsl:text>
  <xsl:value-of select="name()"/>
</xsl:template>

  <xsl:template match="text()" mode="make-step">
  <xsl:text>/</xsl:text>
  <xsl:text>text()</xsl:text>
  <xsl:if test="(preceding-sibling::text()|following-sibling::text())">
    <xsl:text>[</xsl:text>
    <xsl:number/>
    <xsl:text>]</xsl:text>
  </xsl:if>
</xsl:template>

  <xsl:template match="processing-instruction()" mode="make-step">
  <xsl:text>/</xsl:text>
  <xsl:text>text()</xsl:text>
  <xsl:if test="(preceding-sibling::processing-instruction()|following-sibling::processing-instruction())">
    <xsl:text>[</xsl:text>
    <xsl:number/>
    <xsl:text>]</xsl:text>
  </xsl:if>
</xsl:template>

  <xsl:template match="comment()" mode="make-step">
  <xsl:text>/</xsl:text>
  <xsl:text>text()</xsl:text>
  <xsl:if test="(preceding-sibling::comment()|following-sibling::comment())">
    <xsl:text>[</xsl:text>
    <xsl:number/>
    <xsl:text>]</xsl:text>
  </xsl:if>
</xsl:template>

</xsl:stylesheet>